#include <cstdio>
#include <cassert>
#include <cstdlib>
#include <algorithm>
#include <set>

#include "random.h"

using namespace std;

const int maxN = 300;

int n, a[maxN], d[maxN];

int main( int argc, char *argv[] ) {
  assert(argc == 4);
  n = atoi(argv[1]);
  initrand(atoi(argv[3]));
  int k = 300;
  for (int i = 0; i < k; i++) {
    d[i] = R(2, 300);
  }
  set <int> s;
  for (int i = 0; i < n; i++) {
    int t;
    do {
      t = d[R(0, k - 1)] * d[R(0, k - 1)];
    } while (s.count(t) > 0);
    a[i] = t;
    s.insert(t);
  }
  sort(a, a + n);
  n = unique(a, a + n) - a;
  printf("%d\n", n);
  for (int i = 0; i < n; i++) {
    printf("%d%c", a[i], " \n"[i + 1 == n]);
  }
  return 0;
}
