#include "testlib.h"

#include <vector>
#include <algorithm>

using namespace std;

vector <int> readAns( InStream &in, TResult err ) {
  int k = in.readInt();
  vector <int> res(k);
  for (int i = 0; i < k; i++) {
    res[i] = in.readInt();
  }
  sort(res.begin(), res.end());
  return res;
}

int main( int argc, char *argv[] ) {
  registerTestlibCmd(argc, argv);
  vector <int> ja = readAns(ans, _fail);
  vector <int> pa = readAns(ouf, _wa);
  if (ja != pa) {
    quitf(_wa, "Sets do not match");
  } else {
    quitf(_ok, "%d elements", (int)pa.size());
  }
  return -1;
}
