#include <cstdio>
#include <cassert>
#include <cstdlib>
#include <algorithm>

#include "random.h"

using namespace std;

const int maxN = 200;

int n, a[maxN];

int main( int argc, char *argv[] ) {
  assert(argc == 4);
  n = atoi(argv[1]);
  int m = atoi(argv[2]);
  initrand(atoi(argv[3]));
  for (int i = 0; i < n; i++) {
    a[i] = (i % (n - 1) + 239) * 13;
  }
  sort(a, a + n);
  n = unique(a, a + n) - a;
  printf("%d\n", n);
  for (int i = 0; i < n; i++) {
    printf("%d%c", a[i], " \n"[i + 1 == n]);
  }
  return 0;
}
