#include "testlib.h"

#include <algorithm>
#include <vector>

using namespace std;

const int minN = 1;
const int maxN = 200;
const int minX = 1;
const int maxX = 100000;

int main() {
  registerValidation();
  int n = inf.readInt(minN, maxN);
  inf.readEoln();
  vector <int> a(n);
  for (int i = 0; i < n; i++) {
    a[i] = inf.readInt(minX, maxX);
    if (i + 1 < n) {
      inf.readSpace();
    }
  }
  inf.readEoln();
  inf.readEof();
  sort(a.begin(), a.end());
  for (int i = 1; i < n; i++) {
    ensure(a[i - 1] != a[i]);
  }
  return 0;
}
